searchNodes=[{"doc":"Anka and its binding projects provide base model structure and macros to increase modularity of Elixir projects with DRY principle. Installation The package is available in Hex, it can be installed by adding :anka to your list of dependencies in mix.exs: def deps() do [ {:anka, &quot;~&gt; 0.1.1&quot;} ] end","ref":"Anka.html","title":"Anka","type":"module"},{"doc":"Anka generators derive new structures from Anka models. A generator simply must have generate/1 and generate/2 macros which will be used while deriving new structures from model definitions. Examples defmodule Generator.Struct do @behaviour Anka.Generator @impl Anka.Generator defmacro generate(model, _opts \\\\ []) do model_expanded = Macro.expand(model, __CALLER__) definition = Anka.Model.spec(model_expanded, [:struct, :fields], default: []) |&gt; Enum.map(fn {key, field_spec} -&gt; default_value = Anka.Model.spec(field_spec, [:opts, :default], default: []) {key, default_value} key -&gt; {key, nil} end) |&gt; Keyword.new() quote do @before_compile unquote(__MODULE__) @definition unquote(definition) end end defmacro __before_compile__(_env) do quote do defstruct @definition end end end defmodule Struct.Document do require Generator.Struct, as: StructGenerator StructGenerator.generate(Model.Document) end iex&gt; %Struct.Document{} %Struct.Document{id: nil, content: &quot;&quot;}","ref":"Anka.Generator.html","title":"Anka.Generator","type":"behaviour"},{"doc":"","ref":"Anka.Generator.html#c:generate/1","title":"Anka.Generator.generate/1","type":"macrocallback"},{"doc":"","ref":"Anka.Generator.html#c:generate/2","title":"Anka.Generator.generate/2","type":"macrocallback"},{"doc":"Anka models are used by Anka generators to derive new structures from them. A model simply must have spec/0, spec/1 and spec/2 functions to provide information about its definition, specially for Anka generators to derive new structures by using these definitions. The structure of a model definition may change based on needs of generators will be used by developers. Developers are able to implement their own spec functions while defining their models, but unless otherwise required, it is highly recommended to use Anka.Model.__using__/1 macro instead. Examples defmodule Document do use Anka.Model, [ name: [ singular: :document, plural: :documents, ], struct: [ fields: [ :id, content: [ opts: [ default: &quot;&quot; ] ] ] ] ] end","ref":"Anka.Model.html","title":"Anka.Model","type":"behaviour"},{"doc":"Embeds default spec/0, spec/1 and spec/2 functions into the caller module with given model definition opts.","ref":"Anka.Model.html#__using__/1","title":"Anka.Model.__using__/1","type":"macro"},{"doc":"Should return definition of the model.","ref":"Anka.Model.html#c:spec/0","title":"Anka.Model.spec/0","type":"callback"},{"doc":"Returns definition of model. Examples iex&gt; Anka.Model.spec(Model.Document) [ name: [ singular: :document, plural: :documents ], struct: [ fields: [ :id, content: [ opts: [ default: &quot;&quot; ] ] ] ] ] iex&gt; Anka.Model.spec(Model.Document) == Model.Document.spec() true","ref":"Anka.Model.html#spec/1","title":"Anka.Model.spec/1","type":"function"},{"doc":"Should return the value stored under path in the model definition.","ref":"Anka.Model.html#c:spec/1","title":"Anka.Model.spec/1","type":"callback"},{"doc":"Should return the value stored under path in the model definition. Options that are recommended to support: default: If value is nil, default value will be returned in its place. (Default: nil)","ref":"Anka.Model.html#c:spec/2","title":"Anka.Model.spec/2","type":"callback"},{"doc":"Returns the value stored under path in the model definition. Options: default: If value is nil, default value will be returned in its place. (Default: nil) Examples iex&gt; Anka.Model.spec(Model.Document, :name, default: []) [singular: :document, plural: :documents] iex&gt; Anka.Model.spec([singular: :document, plural: :documents], :singular) :document iex&gt; Anka.Model.spec(Model.Document, [:struct, :fields, Access.at(0)]) :id","ref":"Anka.Model.html#spec/3","title":"Anka.Model.spec/3","type":"function"},{"doc":"","ref":"Anka.Model.html#t:container/0","title":"Anka.Model.container/0","type":"type"},{"doc":"","ref":"Anka.Model.html#t:path/0","title":"Anka.Model.path/0","type":"type"},{"doc":"","ref":"Anka.Model.html#t:t/0","title":"Anka.Model.t/0","type":"type"},{"doc":"","ref":"Anka.Model.html#t:value/0","title":"Anka.Model.value/0","type":"type"}]